$MaxLaunchVector = 20;

datablock AudioProfile(slapHandSwingSound)
{
	filename = "./slapHandSwing.wav";
	description = AudioClosestLooping3d;
	preload = true;
};

datablock AudioProfile(slapHandSlap1Sound)
{
	filename = "./Slap1.wav";
	description = AudioDefault3D;
	preload = true;
};

datablock AudioProfile(slapHandSlap2Sound)
{
	filename = "./Slap2.wav";
	description = AudioDefault3D;
	preload = true;
};

datablock AudioProfile(slapHandSlap3Sound)
{
	filename = "./Slap3.wav";
	description = AudioDefault3D;
	preload = true;
};

datablock ParticleData(slapHandRocketParticle)
{
	dragCoefficient = 0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0;
	constantAcceleration = 0.0;
	lifetimeMS = 100;
	lifetimeVarianceMS = 50;
	spinSpeed = 150.0;
	spinRandomMin = -150.0;
	spinRandomMax = 150.0;
	useInvAlpha = "0";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "base/data/particles/cloud";
	animTexName[0] = "base/data/particles/cloud";
	colors[0] = "0.87 0.4 0 1";
	colors[1] = "0.87 0 0 0";
	colors[2] = "1 1 1 1";
	colors[3] = "1 1 1 1";
	sizes[0] = "0.3";
	sizes[1] = "0.1";
	sizes[2] = "0.06";
	sizes[3] = "0.01";
	times[0] = "0";
	times[1] = "1";
	times[2] = "2";
	times[3] = "2";
};

datablock ParticleEmitterData(slapHandRocketEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 1;
	velocityVariance = 3;
	ejectionOffset = 0;
	thetaMin = 0;
	thetaMax = 1;
	phiReferenceVel = 0;
	phiVariance = 1;
	overrideAdvance = 0;
	particles = slapHandRocketParticle;
	uiName = "Slap Hand - Rocket Fire";
};

datablock ParticleData(slapHandSparkParticle)
{
	dragCoefficient = 4;
	gravityCoefficient = 1;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 400;
	lifetimeVarianceMS = 300;
	textureName = "base/data/particles/chunk";
	spinSpeed = 150.0;
	spinRandomMin = -150.0;
	spinRandomMax = 150.0;
	colors[0] = "0.30 0.10 0.0 0.0";
	colors[1] = "0.30 0.10 0.0 0.5";
	colors[2] = "0.30 0.10 0.0 0.0";
	sizes[0] = 0.15;
	sizes[1] = 0.15;
	sizes[2] = 0.15;
	times[0] = 0.1;
	times[1] = 0.5;
	times[2] = 1.0;
	useInvAlpha = true;
};

datablock ParticleEmitterData(slapHandSparkEmitter)
{
	lifeTimeMS = 10;
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 5;
	velocityVariance = 3.0;
	ejectionOffset = 1.50;
	thetaMin = 0;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = slapHandSparkParticle;
	uiName = "";
};

datablock ParticleData(slapHandExplosionParticle)
{
	dragCoefficient = 10;
	gravityCoefficient = -0.15;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0;
	lifetimeMS = 800;
	lifetimeVarianceMS = 500;
	textureName = "base/data/particles/cloud";
	spinSpeed = 50;
	spinRandomMin = -500;
	spinRandomMax = 500;
	colors[0] = "1 1 1 0.25";
	colors[1] = "0 0 0 0";
	sizes[0] = 0.5;
	sizes[1] = 1;
	useInvAlpha = true;
};

datablock ParticleEmitterData(slapHandExplosionEmitter)
{
	lifeTimeMS = 50;
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 10;
	velocityVariance = 1.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 95;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = slapHandExplosionParticle;
	uiName = "";
	emitterNode = HalfEmitterNode;
};

datablock ExplosionData(slapHandExplosion)
{
	lifeTimeMS = 400;
	emitter[0] = slapHandSparkEmitter;
	particleEmitter = slapHandExplosionEmitter;
	particleDensity = 30;
	particleRadius = 1.0;
	faceViewer = true;
	explosionScale = "1 1 1";
	shakeCamera = true;
	cameraShakeFalloff = false;
	camShakeFreq = "2.0 3.0 1.0";
	camShakeAmp = "1.0 1.0 1.0";
	camShakeDuration = 2.5;
	camShakeRadius = 0.0001;
	lightStartRadius = 0;
	lightEndRadius = 0;
	lightStartColor = "0.0 0.0 0.0";
	lightEndColor = "0 0 0";
};

datablock ProjectileData(slapHandProjectile)
{
	directDamage = 13;
	impactImpulse = 2000;
	verticalImpulse = 2000;
	explosion = slapHandExplosion;
	muzzleVelocity = 50;
	velInheritFactor = 1;
	armingDelay = 0;
	lifetime = 100;
	fadeDelay = 70;
	bounceElasticity = 0;
	bounceFriction = 0;
	isBallistic = false;
	gravityMod = 0.0;
	hasLight = false;
	lightRadius = 3.0;
	lightColor = "0 0 0.5";
	uiName = "Slap Hand Projectile";
};

datablock ItemData(slapHandItem)
{
	category = "Weapons";
	className = "Weapon";
	shapeFile = "./slapHand.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Slap Hand";
	iconName = "./icon_slapHand";
	doColorShift = 0;
	image = slapHandImage;
	canDrop = true;
};

datablock ShapeBaseImageData(slapHandImage)
{
	shapeFile = "./slapHand.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	correctMuzzleVector = false;
	className = "WeaponImage";
	item = slapHandItem;
	ammo = " ";
	projectile = slapHandProjectile;
	projectileType = Projectile;
	melee = true;
	doRetraction = false;
	armReady = true;
	doColorShift = 0;

	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.35;
	stateTransitionOnTriggerDown[0] = "PreReady";
	stateTransitionOnTimeout[0] = "PreReady";
	stateSequence[0] = "equip";
	stateScript[0] = "onEquip";
	
	stateName[1] = "PreReady";
	stateScript[1] = "onReady";
	stateAllowImageChange[1] = true;
	stateTimeoutValue[1] = 0.0;
	stateTransitionOnTimeout[1] = "Ready";
	
	stateName[2] = "Ready";
	stateTransitionOnTriggerDown[2] = "PreFire";
	stateAllowImageChange[2] = true;

	stateName[3] = "PreFire";
	stateScript[3] = "onPreFire";
	stateAllowImageChange[3] = true;
	stateTimeoutValue[3] = 0.01;
	stateTransitionOnTimeout[3] = "Fire";
	
	stateName[4] = "Fire";
	stateTransitionOnTimeout[4] = "Fire";
	stateTimeoutValue[4] = 0.2;
	stateFire[4] = true;
	stateAllowImageChange[4] = true;
	stateScript[4] = "onFire";
	stateWaitForTimeout[4] = true;
	stateTransitionOnTriggerUp[4] = "StopFire";
	stateSound[4] = slapHandSwingSound;
	stateEmitter[4]	= "slapHandRocketEmitter";
	stateEmitterNode[4] = "mount0";
	stateEmitterTime[4] = 0.4;

	stateName[5] = "CheckFire";
	stateTransitionOnTriggerUp[5] = "StopFire";
	stateTransitionOnTriggerDown[5]	= "Fire";
	
	stateName[6] = "StopFire";
	stateTransitionOnTimeout[6] = "Ready";
	stateTimeoutValue[6] = 0.2;
	stateAllowImageChange[6] = true;
	stateWaitForTimeout[6] = true;
};

function slapHandImage::onFire(%this, %obj, %slot)
{
	Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, rotCW);
}

function slapHandImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function slapHandProjectile::onExplode(%this, %obj, %pos)
{
	serverPlay3D("slapHandSlap" @ getRandom(1,3) @ "Sound", %pos);
}

function slapHandProjectile::onCollision(%data, %projectile, %hit, %fade, %pos, %normal, %velocity)
{
	if(!isObject(%hit))
		return;
	if(%hit.getClassName() $= "Player" || %hit.getClassName() $= "AIPlayer")
	{
		%hit.setVelocity(getRandom($MaxLaunchVector * -1, $MaxLaunchVector) SPC getRandom($MaxLaunchVector * -1, $MaxLaunchVector) SPC getRandom(10, $MaxLaunchVector * 1.25));
		tumble(%hit);
	}
	else
		return;
}